/* (c) https://github.com/MontiCore/monticore */
/* generated by template templates.de.monticore.lang.montiarc.tagschema.ValuedTagType*/


package nfp.CompPower;

import de.monticore.lang.montiarc.tagging._symboltable.TagKind;
import de.monticore.lang.montiarc.tagging._symboltable.TagSymbol;

import org.jscience.physics.amount.Amount;
import javax.measure.quantity.Power;
import javax.measure.unit.Unit;

/**
 * Created by ValuedTagType.ftl
 */
public class CompPowerInstSymbol extends TagSymbol {
  public static final CompPowerInstKind KIND = CompPowerInstKind.INSTANCE;

  public CompPowerInstSymbol(Amount<Power> value) {
    this(KIND, value);
  }

  public CompPowerInstSymbol(Number number, Unit<Power> unit) {
    this(KIND, number, unit);
  }

  protected CompPowerInstSymbol(CompPowerInstKind kind, Amount<Power> value) {
    super(kind, value);
  }

  protected CompPowerInstSymbol(CompPowerInstKind kind, Number number, Unit<Power> unit) {
    this(kind, number.toString().contains(".") ?
      Amount.valueOf(number.doubleValue(), unit) :
      Amount.valueOf(number.intValue(),
          unit));
  }

  public Amount<Power> getValue() {
     return getValue(0);
  }

  public Number getNumber() {
    return getValue().getExactValue();
  }

  public Unit<Power> getUnit() {
    return getValue().getUnit();
  }

  @Override
  public String toString() {
    return String.format("CompPowerInst = %s %s",
      getNumber(), getUnit());
  }

  public static class CompPowerInstKind extends TagKind {
    public static final CompPowerInstKind INSTANCE = new CompPowerInstKind();

    protected CompPowerInstKind() {
    }
  }
}
